Application Description: GAILBase.apl
		This library defines base class used by all generated classes for GAIL.
		This base class implements serialze/deserialize data pass/receive to/from .NET method call,
		and function to invoke .NET method/getter/setter.
	Outline Version - 4.0.57
	Design-time Settings
.data VIEWINFO
0000: 6F00000001000000 FFFF01000D004347 5458566965775374 6174650400010000
0020: 0000000000020100 002C000000020000 0003000000FFFFFF FFFFFFFFFFF8FFFF
0040: FFE1FFFFFF4B0000 004B000000A60500 00AF020000010000 0001000000010000
0060: 00FFFEFF0F410070 0070006C00690063 006100740069006F 006E004900740065
0080: 006D0000000000
.enddata
		Outline Window State: Normal
		Outline Window Location and Size
		Options Box Location
		Class Editor Location
		Tool Palette Location
		Fully Qualified External References? Yes
		Reject Multiple Window Instances? No
		Enable Runtime Checks Of External References? Yes
		Use Release 4.0 Scope Rules? No
		Edit Fields Read Only On Disable? No
		Assembly Symbol File:
	Libraries
		File Include: vtstr.apl
		File Include: vtfile.apl
		File Include: vtdos.apl
	Global Declarations
		Window Defaults
			Tool Bar
				Display Style? Etched
				Font Name: Microsoft Sans Serif
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Form Window
				Display Style? Etched
				Font Name: Microsoft Sans Serif
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Dialog Box
				Display Style? Etched
				Font Name: Microsoft Sans Serif
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Top Level Table Window
				Font Name: Microsoft Sans Serif
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Top Level Grid Window
				Font Name: Microsoft Sans Serif
				Font Size: System Default
				Font Enhancement: System Default
				Text Color: System Default
				Background Color: System Default
			Data Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Multiline Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Spin Field
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Background Text
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Pushbutton
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Radio Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Check Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Option Button
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Group Box
				GroupBox Style: Etched
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Line Color: Use Parent
				Flow Direction: Default
			Child Table Window
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			List Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Combo Box
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Line
				Line Color: Use Parent
			Frame
				Border Color: Use Parent
				Background Color: Use Parent
			Picture
				Border Color: Use Parent
				Background Color: Use Parent
			Date Time Picker
				Text Color: Use Parent
				Background Color: Use Parent
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
			Child Grid Window
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Rich Text Control
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Date Picker
				Font Name: Use Parent
				Font Size: Use Parent
			Tree Control
				Font Name: Use Parent
				Font Size: Use Parent
				Flow Direction: Default
			Navigation Bar
				Text Color: Use Parent
				Background Color: Use Parent
				Flow Direction: Default
			Pane Separator
			Tab Bar
				Font Name: Use Parent
				Font Size: Use Parent
				Font Enhancement: Use Parent
				Text Color: Use Parent
				Background Color: Use Parent
			Progress Bar
				Background Color: Use Parent
		Formats
			Number: 0'%'
			Number: #0
			Number: ###000
			Number: ###000;'($'###000')'
			Date/Time: hh:mm:ss AMPM
			Date/Time: M/d/yy
			Date/Time: MM-dd-yy
			Date/Time: dd-MMM-yyyy
			Date/Time: MMM d, yyyy
			Date/Time: MMM d, yyyy hh:mm AMPM
			Date/Time: MMMM d, yyyy hh:mm AMPM
		External Functions
			Library name: cdlli74.dll
				ThreadSafe: No
				Function: TriggerNetException
					Description:
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
			Library name: GAILWrapper.dll
				ThreadSafe: No
				Function: GAIL_LoadGACAssembly
					Description: Calls LoadAssembly method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
				Function: GAIL_LoadCustomAssembly
					Description: Calls LoadAssembly method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
						String: LPWSTR
				Function: GAIL_ReleaseAssembly
					Description: Calls ReleaseAssembly method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
				Function: GAIL_CreateObject
					Description: Calls CreateObject method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
						Receive Number: LPINT
						String: LPWSTR
				Function: GAIL_ReleaseObject
					Description: Calls ReleaseObject method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: INT
				Function: GAIL_SetProperty
					Description: Calls GAIL_SetProperty method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: INT
						String: LPWSTR
						String: LPWSTR
				Function: GAIL_GetProperty
					Description: Calls GAIL_GetProperty method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: INT
						String: LPWSTR
						Receive Number: LPINT
				Function: GAIL_GetLastError
					Description: Calls GetLastError method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Receive String: LPWSTR
				Function: GAIL_DeserializeString
					Description: Calls DeserializeString method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Receive String: LPWSTR
				Function: GAIL_DeserializeBinary
					Description: Calls DeserializeBinary method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
						Receive Binary: LPBYTE
				Function: GAIL_InvokeMethod_Overload1
					Description: Calls InvokeMethod_Overload1 method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Number: INT
						String: LPWSTR
						String: LPWSTR
						Receive Number: LPINT
				Function: GAIL_InvokeMethod_Overload2
					Description: Calls InvokeMethod_Overload2 method of GAIL library.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						String: LPWSTR
						String: LPWSTR
						String: LPWSTR
						Receive Number: LPINT
				Function: GAIL_GetResultPayload
					Description: Gets the result payload.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Receive String: LPWSTR
				Function: GAIL_SerializeBinary
					Description: Gets the result payload.
					Export Ordinal: 0
					Returns
						Boolean: BOOL
					Parameters
						Receive Binary: LPBYTE
						Number: INT
						Receive String: LPWSTR
		External Assemblies
		Constants
.data CCDATA
0000: 3000000000000000 0000000000000000 0000000000000000 0000000000000000
0020: 0000000000000000
.enddata
.data CCSIZE
0000: 2800
.enddata
			System
			User
				Number: PAYLOADBUFFERSIZE = 2000
				String: BYREFSTRING = " byref=\"true\""
			Enumerations
		Resources
		Variables
			FunctionalVar: __netBase
				Class: Unify_TD_GAIL_CNETBase
			Boolean: bGailDisableAutoReportErrors
			Number: nGailErrorMsg
		Internal Functions
		Named Exceptions
		Named Toolbars
		Named Menus
		Class Definitions
			Functional Class: Unify_TD_GAIL_CNETBase
				Description:
				Derived From
				Class Variables
				Instance Variables
					String: m_AssemblyName
					String: m_ClassName
					Number: m_ObjectID
					String: m_LastError
				Constructor/Destructor
				Functions
					Function: __Base_Constructor_Overload1
						Description: Loads given assembly and then instantiates class object using GAIL.
						Returns
							Boolean:
						Parameters
							String: assemblyName
							String: className
							String: parameters
						Static Variables
						Local variables
						Actions
							Set m_AssemblyName = assemblyName
							Set m_ClassName = className
							Call SalSetBufferLength( m_LastError, PAYLOADBUFFERSIZE )
							If ( GAIL_LoadGACAssembly( m_AssemblyName ) )
								Return GAIL_CreateObject( m_ClassName, m_ObjectID, parameters )
							Else
								Call __Base_ReportError( className || ' ctor' )
								Return FALSE
					Function: __Base_Constructor_Overload2
						Description: Loads given assembly and then instantiates class object using GAIL.
						Returns
							Boolean:
						Parameters
							String: assemblyName
							String: className
							String: parameters
						Static Variables
						Local variables
							String: appDir
							String: sAssemblyFullPath
							String: sDir
							String: sDrive
							String: sBase
							String: sExt
						Actions
							Set m_AssemblyName = assemblyName
							Set m_ClassName = className
							Call SalSetBufferLength( m_LastError, PAYLOADBUFFERSIZE )
							Call SalFileGetCurrentDirectory( appDir )
							!
							! The assembly can be in 1) Current folder or 2) Runtime folder where app is started or 3) Any folder in PATH
							! So to get the correct assembly location: check in that order
							!
							If NOT VisDosExist( appDir || "\\" || m_AssemblyName )		! Is assembly at location of the current directory? The app could have set it explicitly
								! Now check the the runtime folder where application is running from OR when debugging, the location where the source is loaded from
								Call VisDosSplitPath( strArgArray[0], sDrive, sDir, sBase, sExt )
								Set appDir = sDrive || sDir
								If NOT VisDosExist( appDir || m_AssemblyName )		! Is assembly at location of the runtime directory? The assembly is installed at the application location
									Set sAssemblyFullPath = VisFileFind( assemblyName )	! Find it anywhere in PATH, give the full path filename
									If sAssemblyFullPath
										! Yes, found. Split the dir elements
										Call VisDosSplitPath( sAssemblyFullPath, sDrive, sDir, sBase, sExt )
										Set appDir = sDrive || sDir
									! If still not found, let GAIL report the error
							!
							If ( GAIL_LoadCustomAssembly(appDir, m_AssemblyName ) )
								Return GAIL_CreateObject( m_ClassName, m_ObjectID, parameters )
							Else
								Call __Base_ReportError( className || ' ctor' )
								Return FALSE
					Function: __Base_Serialize_Init
						Description: Instantiates method parameters.
						Returns
							String:
						Parameters
						Static Variables
						Local variables
						Actions
							Return ''
					Function: __Base_Serialize_String
						Description: Serializes string parameter.
						Returns
							String:
						Parameters
							String: value
							Receive String: paramPayLoad
							Boolean: isByRef
						Static Variables
						Local variables
						Actions
							! IF statement handles that STRING_Null equals empty string.
							If value = '' And Not isByRef And SalStringToBinary(value, ENC_ANSI) = BINARY_Null
								Set paramPayLoad = paramPayLoad || '<ObjectNull Type="String"/>'
								Return paramPayLoad
							Set value = VisStrSubstitute( value, "&", "&amp;" )
							Set value = VisStrSubstitute( value, "<", "&lt;" )
							Set value = VisStrSubstitute( value, ">", "&gt;" )
							!
							Set paramPayLoad = paramPayLoad || '<String xml:space="preserve"'
							If isByRef
								Set paramPayLoad = paramPayLoad || BYREFSTRING
							Set paramPayLoad = paramPayLoad || '>' || value || '</String>'
							Return paramPayLoad
					Function: __Base_Serialize_Binary
						Description: Serializes binary parameter.
						Returns
							String:
						Parameters
							Binary: value
							Receive String: paramPayLoad
							String: binaryType
							Boolean: isByRef
						Static Variables
						Local variables
							String: encodedValue
						Actions
							If value != BINARY_Null And Not isByRef
								Set encodedValue = SalBinaryToString( value, ENC_BASE64 )
							Else
								Set encodedValue = ''
							Set paramPayLoad = paramPayLoad || '<Binary binarytype="' || binaryType || '"'
							If isByRef
								Set paramPayLoad = paramPayLoad || BYREFSTRING
							Set paramPayLoad = paramPayLoad || '>' || encodedValue || '</Binary>'
							Return paramPayLoad
					Function: __Base_Serialize_Number
						Description: Serializes number parameter.
						Returns
							String:
						Parameters
							Number: value
							Receive String: paramPayLoad
							String: numberType
							Boolean: isByRef
						Static Variables
						Local variables
							Number: nDecimal
						Actions
							If value = NUMBER_Null And Not isByRef
								Set paramPayLoad = paramPayLoad || '<ObjectNull Type="Number"/>'
								Return paramPayLoad
							Set nDecimal = __Base_NumberFormatString(numberType)
							Set paramPayLoad = paramPayLoad || '<Number numtype="' || numberType || '"'
							If isByRef
								Set paramPayLoad = paramPayLoad || BYREFSTRING
							Set paramPayLoad = paramPayLoad || '>' || SalNumberToStrX ( value, nDecimal ) || '</Number>'
							Return paramPayLoad
					Function: __Base_Serialize_Boolean
						Description: Serializes boolean parameter.
						Returns
							String:
						Parameters
							Boolean: value
							Receive String: paramPayLoad
							Boolean: isByRef
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = paramPayLoad || '<Boolean'
							If isByRef
								Set paramPayLoad = paramPayLoad || BYREFSTRING
							If value
								Set paramPayLoad = paramPayLoad || '>TRUE</Boolean>'
							Else
								Set paramPayLoad = paramPayLoad || '>FALSE</Boolean>'
							Return paramPayLoad
					Function: __Base_Serialize_DateTime
						Description: Serializes datetime parameter.
						Returns
							String:
						Parameters
							Date/Time: value
							Receive String: paramPayLoad
							Boolean: isByRef
						Static Variables
						Local variables
							String: strDate
						Actions
							If value = DATETIME_Null And Not isByRef
								Set paramPayLoad = paramPayLoad || '<ObjectNull Type="DateTime"/>'
								Return paramPayLoad
							Set strDate = SalFmtFormatDateTime( value, "yyyy-MM-dd'T'hhhh:mm:ss.mmmmmm" )
							Set paramPayLoad = paramPayLoad || '<DateTime'
							If isByRef
								Set paramPayLoad = paramPayLoad || BYREFSTRING
							Set paramPayLoad = paramPayLoad || '>' || strDate || '</DateTime>'
							Return paramPayLoad
					Function: __Base_Serialize_Finalize
						Description: Completes parameters serialization.
						Returns
							String:
						Parameters
							Receive String: paramPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = '<Parameters>' || paramPayLoad || '</Parameters>'
							Return paramPayLoad
					Function: __Base_Serialize_Object
						Description: Serializes object parameter.
						Returns
							String:
						Parameters
							Receive String: paramPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = paramPayLoad || '<ObjectInstance><ObjectID>' || SalNumberToStrX ( m_ObjectID , 0 ) || '</ObjectID><Class>' || m_ClassName || '</Class></ObjectInstance>'
							Return paramPayLoad
					Function: __Base_Serialize_ByRefObject
						Description: Serializes object parameter.
						Returns
							String:
						Parameters
							Receive String: paramPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = paramPayLoad || '<ObjectInstance><ObjectID>' || SalNumberToStrX ( m_ObjectID , 0 ) || '</ObjectID><Class>' || m_ClassName || '</Class><ByRef>true</ByRef></ObjectInstance>'
							Return paramPayLoad
					Function: __Base_Serialize_Enum
						Description: Serializes enum parameter.
						Returns
							String:
						Parameters
							Number: value
							String: enumType
							Receive String: paramPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = paramPayLoad || '<Enum><Value>' || SalNumberToStrX ( value, 0 ) || '</Value><Type>' || enumType || '</Type></Enum>'
							Return paramPayLoad
					Function: __Base_NumberFormatString
						Description: Get the format string for serializing a number base on the .NET number type.
						Returns
							Number:
						Parameters
							String: numberType
						Static Variables
						Local variables
						Actions
							If SalStrLeftX ( numberType, 3 ) = 'Int'
								Return 0
							If SalStrLeftX ( numberType, 4 ) = 'UInt'
								Return 0
							If numberType = 'Single'
								Return 8
							If numberType = 'Double'
								Return 8
							If numberType = 'Decimal'
								Return 4
							Return 0
					Function: __Base_Deserialize_Init
						Description: Instantiates method parameters.
						Returns
							String:
						Parameters
							String: paramPayLoad
						Static Variables
						Local variables
						Actions
							Return SalStrMidX( paramPayLoad, SalStrLength( '<Parameter>' ), SalStrCharLength( paramPayLoad ) )
					Function: __Base_Deserialize_String
						Description: Deserializes stirng value.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
							Receive String: returnPayLoad
						Static Variables
						Local variables
							Boolean: bRet
						Actions
							If SalStrLeftX( paramPayLoad, SalStrLength( "<ObjectNull />" ) ) = "<ObjectNull />"
								Set returnPayLoad = STRING_Null
								Set paramPayLoad = SalStrRightX( paramPayLoad, SalStrCharLength( paramPayLoad ) - SalStrLength( "<ObjectNull />" ) )
								Return TRUE
							Set bRet = TRUE
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<STRING' ), SalStrCharLength( paramPayLoad ) )
							If SalStrLeftX( paramPayLoad, 3 ) = ' />'
								Set paramPayLoad = SalStrMidX( paramPayLoad, 2, SalStrCharLength( paramPayLoad ) )
								Set returnPayLoad = ''
							Else
								Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan(paramPayLoad, '>') + 1, SalStrCharLength( paramPayLoad ) )
								Set returnPayLoad = SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</STRING>' ) )
								Set bRet = GAIL_DeserializeString(returnPayLoad)
								Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</STRING>' ) + 9, SalStrCharLength( paramPayLoad ) )
							Return bRet
					Function: __Base_Deserialize_Binary
						Description: Deserializes binary value.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
							Receive Binary: returnPayLoad
						Static Variables
						Local variables
							String: buffer
							Number: decodedSize
						Actions
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<BINARY' ), SalStrCharLength( paramPayLoad ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan(paramPayLoad, '>') + 1, SalStrCharLength( paramPayLoad ) )
							Set buffer = SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</BINARY>' ) )
							Set returnPayLoad = SalStringToBinary( buffer, ENC_BASE64 )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</BINARY>' ) + 9, SalStrCharLength( paramPayLoad ) )
					Function: __Base_Deserialize_Number
						Description: Deserializes number value.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
							Receive Number: returnPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<NUMBER' ), SalStrCharLength( paramPayLoad ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan(paramPayLoad, '>') + 1, SalStrCharLength( paramPayLoad ) )
							Set returnPayLoad = SalStrToNumber( SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</NUMBER>' ) ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</NUMBER>' ) + 9, SalStrCharLength( paramPayLoad ) )
					Function: __Base_Deserialize_Boolean
						Description: Deserializes stirng value.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
							Receive Boolean: returnPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<BOOLEAN' ), SalStrCharLength( paramPayLoad ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan(paramPayLoad, '>') + 1, SalStrCharLength( paramPayLoad ) )
							If SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</BOOLEAN>' ) ) = 'TRUE'
								Set returnPayLoad = TRUE
							Else
								Set returnPayLoad = FALSE
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</BOOLEAN>' ) + 10, SalStrCharLength( paramPayLoad ) )
					Function: __Base_Deserialize_DateTime
						Description: Deserializes datetime value.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
							Receive Date/Time: returnPayLoad
						Static Variables
						Local variables
						Actions
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<DATE/TIME' ), SalStrCharLength( paramPayLoad ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan(paramPayLoad, '>') + 1, SalStrCharLength( paramPayLoad ) )
							Set returnPayLoad = SalStrToDate( SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</DATE/TIME>' ) ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</DATE/TIME>' ) + 12, SalStrCharLength( paramPayLoad ) )
					Function: __Base_Deserialize_Object
						Description: Deserializes object parameter.
						Returns
							Boolean:
						Parameters
							Receive String: paramPayLoad
						Static Variables
						Local variables
						Actions
							If SalStrScan( paramPayLoad, "<ObjectNull />" ) = 0
								Set paramPayLoad = SalStrMidX( paramPayLoad, 14, SalStrCharLength( paramPayLoad ) )
								Return FALSE
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrLength( '<ObjectInstance><ObjectID>' ), SalStrCharLength( paramPayLoad ) )
							Set m_ObjectID = SalStrToNumber( SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</ObjectID>' ) ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '<Class>' )+7, SalStrCharLength( paramPayLoad ) )
							Set m_ClassName = SalStrLeftX( paramPayLoad, SalStrScan( paramPayLoad, '</Class></ObjectInstance>' ) )
							Set paramPayLoad = SalStrMidX( paramPayLoad, SalStrScan( paramPayLoad, '</ObjectInstance>' ) + 17, SalStrCharLength( paramPayLoad ) )
							Return TRUE
					Function: __Base_InvokeMethod_Overload1
						Description: Invokes method by invoking it using GAIL library.
						Returns
							Boolean:
						Parameters
							Number: objectID
							String: methodName
							String: payLoad
							Receive String: result
						Static Variables
						Local variables
							Number: resultSize
						Actions
							If GAIL_InvokeMethod_Overload1( objectID, methodName, payLoad, resultSize )
								Call SalSetBufferLength( result, resultSize )
								Call GAIL_GetResultPayload( result )
							Else
								Call __Base_ReportError( methodName )
					Function: __Base_InvokeMethod_Overload2
						Description: Invokes method by invoking it using GAIL library.
						Returns
							Boolean:
						Parameters
							String: className
							String: methodName
							String: payLoad
							Receive String: result
						Static Variables
						Local variables
							Number: resultSize
						Actions
							If GAIL_InvokeMethod_Overload2( className, methodName, payLoad, resultSize )
								Call SalSetBufferLength( result, resultSize )
								Call GAIL_GetResultPayload( result )
							Else
								Call __Base_ReportError( methodName )
					Function: __Base_SetProperty
						Description: Set's property of object by using GAIL library.
						Returns
							Boolean:
						Parameters
							Number: objectID
							String: propertyName
							String: newValue
						Static Variables
						Local variables
						Actions
							Call GAIL_SetProperty( objectID, propertyName, newValue )
					Function: __Base_GetProperty
						Description: Get's property of object by using GAIL library.
						Returns
							Boolean:
						Parameters
							Number: objectID
							String: propertyName
							Receive String: payLoad
						Static Variables
						Local variables
							Number: resultSize
						Actions
							If GAIL_GetProperty( objectID, propertyName, resultSize )
								Call SalSetBufferLength( payLoad, resultSize )
								Call GAIL_GetResultPayload( payLoad )
							Else
								Call __Base_ReportError( propertyName )
					Function: __Base_ReportError
						Description: Reports the last error
						Returns
						Parameters
							String: methodName
						Static Variables
						Local variables
						Actions
							Call SalSetBufferLength( m_LastError, PAYLOADBUFFERSIZE )
							Call GAIL_GetLastError( m_LastError )
							If Not TriggerNetException( )
								If Not bGailDisableAutoReportErrors
									Call SalMessageBox( m_LastError, 'Error executing ' || methodName, 0 )
								Else
									Call SalSendMsg( hWndForm, nGailErrorMsg, SalHStringToNumber(m_LastError) , 0 )
					Function: __Base_Release
						Description: Release the underlying object
						Returns
							Boolean:
						Parameters
						Static Variables
						Local variables
							Boolean: bRet
						Actions
							If GAIL_ReleaseObject(m_ObjectID)
								Set bRet = TRUE
							Else
								Call __Base_ReportError( m_ClassName || ' Release ' )
								Set bRet = FALSE
							Set m_ObjectID = 0
							Return bRet
			Functional Class: System_Object
				Description:
				Derived From
					Class: Unify_TD_GAIL_CNETBase
				Class Variables
				Instance Variables
				Constructor/Destructor
				Functions
					Function: Object
						Description:
						Returns
						Parameters
						Static Variables
						Local variables
							String: payLoad
						Actions
							Set payLoad = __Base_Serialize_Init()
							Set payLoad = __Base_Serialize_Finalize( payLoad )
							Call this.__Base_Constructor_Overload1( 'mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089', 'System.Object', payLoad )
					Function: ToString
						Description:
						Returns
							String:
						Parameters
						Static Variables
						Local variables
							String: payLoad
							String: _returnObject
						Actions
							Set payLoad = __Base_Serialize_Init()
							Set payLoad = __Base_Serialize_Finalize( payLoad )
							Call __Base_InvokeMethod_Overload1( m_ObjectID, 'ToString', payLoad, payLoad )
							Set payLoad = __Base_Deserialize_Init( payLoad )
							Call __Base_Deserialize_String( payLoad, _returnObject )
							Return _returnObject
					Function: Object_Release
						Description:
						Returns
							Boolean:
						Parameters
						Static Variables
						Local variables
						Actions
							Return __Base_Release()
		Default Classes
			MDI Window: cBaseMDI
			Form Window:
			Dialog Box:
			Table Window:
			Grid Window:
			Quest Window:
			Data Field:
			Spin Field:
			Multiline Field:
			Pushbutton:
			Radio Button:
			Option Button:
			Child Grid:
			Rich Text Control:
			Separator:
			Tree Control:
			Navigation Bar:
			Pane Separator:
			Progress Bar:
			Check Box:
			Child Table:
			Quest Child Window: cQuickDatabase
			List Box:
			Combo Box:
			Picture:
			Vertical Scroll Bar:
			Horizontal Scroll Bar:
			Column:
			Background Text:
			Group Box:
			Line:
			Frame:
			Custom Control:
			ActiveX:
			Date Picker:
			Date Time Picker:
			Tab Bar:
		Application Actions
